<?php

namespace App\Controllers;

use App\Helpers\UserHelper;
use App\Libraries\MyAuth\GoogleAuth;
use App\Libraries\MyAuth\LocalAuth;
use App\Models\UserModel;
use CodeIgniter\HTTP\RedirectResponse;
use CodeIgniter\HTTP\RequestInterface;

use CodeIgniter\HTTP\ResponseInterface;
use CodeIgniter\Validation\Validation;
use Google\Service\Oauth2;
use Psr\Log\LoggerInterface;

class UserController extends FrontController
{
    private $_model = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->class_name .= "User";
        $this->class_path .= $this->class_name;
        $this->title = lang("{$this->class_path}.title");
        $this->helper = new UserHelper();
    }
    protected function getModel(): UserModel
    {
        if ($this->_model === null) {
            $this->_model = new UserModel();
        }
        return $this->_model;
    }
    protected function setFormFieldRule($field, Validation $validation, string $action): Validation
    {
        switch ($field) {
            case 'role':
                //아래 Rule Array는 필드명.* checkbox를 사용
                $validation->setRule($field . ".*", $field, $this->getModel()->getFieldRule($action, $field));
                break;
            default:
                $validation = parent::setFormFieldRule($field, $validation, $action);
                break;
        }
        return $validation;
    }
    protected function getFormFieldOption(string $field, array $options = []): array
    {
        switch ($field) {
            default:
                $options = parent::getFormFieldOption($field, $options);
                break;
        }
        return $options;
    }
    protected function getFormData(string $field, array $formDatas): array
    {
        switch ($field) {
            case 'role':
                $roles = $this->request->getVar($field) ?? [];
                if (!count($roles)) {
                    throw new \Exception("권한이 지정되지 않았습니다.");
                }
                $formDatas[$field] = implode(DEFAULTS["DELIMITER_ROLE"], $roles);
                break;
            default:
                $formDatas = parent::getFormData($field, $formDatas);
                break;
        }
        return $formDatas;
    }
    private function getGoogleAuthUrl()
    {
        $params = [
            'client_id' => env('socket.google.client.id'),
            'redirect_uri' => env('socket.google.client.callback_url'),
            'response_type' => 'code',  // 이 줄을 추가하세요
            'scope' => Oauth2::USERINFO_EMAIL . " " . Oauth2::USERINFO_PROFILE,
            'state' => env('socket.google.client.token_name'),
        ];
        return env('socket.google.api.uri') . '?' . http_build_query($params);
    }
    private function init(string $action): void
    {
        $this->action = $action;
        $this->fields = ['id', 'passwd'];
        $this->field_rules = $this->getModel()->getFieldRules($this->action, $this->fields);
    }
    //로그인화면
    public function login_form(): RedirectResponse|string
    {
        $this->init('login');
        try {
            helper(['form']);
            $this->create_form_process();
            $this->session->keepFlashdata(SESSION_NAMES['RETURN_URL']);
            $this->google_url = $this->getGoogleAuthUrl();
            $this->forms = ['attributes' => ['method' => "post",], 'hiddens' => []];
            return view(
                $this->view_path . "login",
                data: ['viewDatas' => $this->getViewDatas()]
            );
        } catch (\Exception $e) {
            log_message("error", $e->getMessage());
            return redirect()->to($this->session->getFlashdata(SESSION_NAMES['RETURN_URL']) ?: "/")->with(SESSION_NAMES['RETURN_MSG'], $e->getMessage());
        }
    }
    //로그인처리
    public function login(): RedirectResponse|string
    {
        $this->init('login');
        //Transaction Start
        $this->getModel()->transStart();
        try {
            $this->create_validate($this->action, $this->fields);
            $this->formDatas = $this->getFormDatas();
            $auth = new LocalAuth();
            $auth->setLogin($auth->checkUser($this->formDatas));
            $this->message = "로그인 성공";
            $this->getModel()->transCommit();
            log_message("notice", $this->message);
            $this->session->setFlashdata(SESSION_NAMES['RETURN_MSG'], $this->message);
            return redirect()->to($this->session->getFlashdata(SESSION_NAMES['RETURN_URL']) ?: "/");
        } catch (\Exception $e) {
            //Transaction Rollback
            $this->getModel()->transRollback();
            log_message("error", $e->getMessage());
            $this->session->setFlashdata(SESSION_NAMES['RETURN_MSG'], "로그인 실패하였습니다.\n" . $e->getMessage());
            $this->session->keepFlashdata(SESSION_NAMES['RETURN_URL']);
            return redirect()->back()->withInput();
        }
    }
    public function google_login(): RedirectResponse|string
    {
        $this->init('login');
        //Transaction Start
        $this->getModel()->transStart();
        try {
            $access_code = $this->request->getVar('code');
            if (!$access_code) {
                throw new \Exception("구글 로그인 실패");
            }
            $auth = new GoogleAuth(env('socket.google.client.token_name'), $access_code);
            $auth->setLogin($auth->checkUser());
            $this->message = "로그인 성공";
            $this->getModel()->transCommit();
            log_message("notice", $this->message);
            $this->session->setFlashdata(SESSION_NAMES['RETURN_MSG'], $this->message);
            return redirect()->to($this->session->getFlashdata(SESSION_NAMES['RETURN_URL']) ?: "/");
        } catch (\Exception $e) {
            //Transaction Rollback
            $this->getModel()->transRollback();
            log_message("error", $e->getMessage());
            $this->session->setFlashdata(SESSION_NAMES['RETURN_MSG'], "로그인 실패하였습니다.\n" . $e->getMessage());
            $this->session->keepFlashdata(SESSION_NAMES['RETURN_URL']);
            return redirect()->back()->withInput();
        }
    }
    //로그아웃
    public function logout(): RedirectResponse
    {
        //Session에 Login 정보 삭제
        session()->set([SESSION_NAMES['ISLOGIN'] => false]);
        session_destroy();
        return redirect()->route('/');
    }
}
